function Event_Chat_Build_Test(Map_ID, Client_ID, Message)
	if string.sub(Message, 1, 5) == "size " then
		Test_Build_Size = tonumber(string.sub(Event_Message, 6, 7))
		System_Message_Network_Send_2_All(Map_ID, "&c Size is now: "..tostring(Test_Build_Size))
	end
end

function Event_Blockchange_Build_Test(Event_Map_ID, Client_ID, Event_X, Event_Y, Event_Z)
	
	local Map_Part = {}
	
	for ix = -Test_Build_Size-2, Test_Build_Size+2 do
		Map_Part[ix] = {}
		for iy = -Test_Build_Size-2, Test_Build_Size+2 do
			Map_Part[ix][iy] = {}
			for iz = -Test_Build_Size-2, Test_Build_Size+2 do
				Map_Part[ix][iy][iz] = 0.0
			end
		end
	end
	
	Player_Number = Map_Block_Get_Player_Last(Event_Map_ID, Event_X, Event_Y, Event_Z)
	Type = Map_Block_Get_Type(Event_Map_ID, Event_X, Event_Y, Event_Z)
	
	if Type > 0 then
		
		for ix = -Test_Build_Size-1, Test_Build_Size+1 do
			for iy = -Test_Build_Size-1, Test_Build_Size+1 do
				for iz = -Test_Build_Size-1, Test_Build_Size+1 do
					if Map_Block_Get_Type(Event_Map_ID, Event_X+ix, Event_Y+iy, Event_Z+iz) > 0 then
						entf = math.sqrt(ix*ix + iy*iy + iz*iz)
						if entf <= Test_Build_Size then
							for iix = -1, 1 do
								for iiy = -1, 1 do
									for iiz = -1, 1 do
										Map_Part[ix+iix][iy+iiy][iz+iiz] = Map_Part[ix+iix][iy+iiy][iz+iiz] + math.random(100)/250
									end
								end
							end
						end
					end
				end
			end
		end
		
		for ix = -Test_Build_Size, Test_Build_Size do
			for iy = -Test_Build_Size, Test_Build_Size do
				for iz = -Test_Build_Size, Test_Build_Size do
					if Map_Part[ix][iy][iz] > 1 and Map_Block_Get_Type(Event_Map_ID, Event_X+ix, Event_Y+iy, Event_Z+iz) == 0 then
						Map_Block_Change_Fast(Player_Number, Event_Map_ID, Event_X+ix, Event_Y+iy, Event_Z+iz, Type, 1, 1, 0, 1)
					end
				end
			end
		end
	
	elseif Type == 0 then
		
		for ix = -Test_Build_Size-1, Test_Build_Size+1 do
			for iy = -Test_Build_Size-1, Test_Build_Size+1 do
				for iz = -Test_Build_Size-1, Test_Build_Size+1 do
					if Map_Block_Get_Type(Event_Map_ID, Event_X+ix, Event_Y+iy, Event_Z+iz) == 0 then
						entf = math.sqrt(ix*ix + iy*iy + iz*iz)
						if entf <= Test_Build_Size then
							for iix = -1, 1 do
								for iiy = -1, 1 do
									for iiz = -1, 1 do
										Map_Part[ix+iix][iy+iiy][iz+iiz] = Map_Part[ix+iix][iy+iiy][iz+iiz] + math.random(100)/250
									end
								end
							end
						end
					end
				end
			end
		end
		
		for ix = -Test_Build_Size, Test_Build_Size do
			for iy = -Test_Build_Size, Test_Build_Size do
				for iz = -Test_Build_Size, Test_Build_Size do
					if Map_Part[ix][iy][iz] > 1 and Map_Block_Get_Type(Event_Map_ID, Event_X+ix, Event_Y+iy, Event_Z+iz) > 0 then
						Map_Block_Change_Fast(Player_Number, Event_Map_ID, Event_X+ix, Event_Y+iy, Event_Z+iz, Type, 1, 1, 0, 1)
					end
				end
			end
		end
		
	end
	
end
