function Gamemode_RP_Player_Inventory_Add(Client_ID, Material_ID, Amount)
	local Player_Number = Client_Get_Player_Number(Client_ID)
	
	Player_Inventory_Set(Player_Number, Material_ID, Player_Inventory_Get(Player_Number, Material_ID)+Amount)
	System_Message_Network_Send(Client_ID, "&bYou got "..tostring(Amount).." '"..Block_Get_Name(Material_ID).."'")
end

function Gamemode_RP_Event_Blockchange(Map_ID, Client_ID, Mode, Material, X, Y, Z)
	local Player_Number = Client_Get_Player_Number(Client_ID)
	local Inventory_Counter = Player_Inventory_Get(Player_Number, Material)
	
	if Player_Attribute_Long_Get(Player_Number, "rpoff") == 1 then
		return 1
	end
	
	if Mode == 1 then
		if Inventory_Counter > 0 then
			Player_Inventory_Set(Player_Number, Material, Player_Inventory_Get(Player_Number, Material)-1)
		else
			System_Message_Network_Send(Client_ID, "&cNot enough Blocks in your Invetory!")
			return 0
		end
	end
	
	Actual_Material = Map_Block_Get_Type(Map_ID, X, Y, Z)
	
	local Number = 1
	Dig_Time = 0.2
	Locked = 0
	
	-- Air
	if Actual_Material == 0 then Dig_Time, Number = 0, 0 end
	-- Stone to Cobblestone
	if Actual_Material == 1 then Locked, Dig_Time, Actual_Material = 1, 1, 4 end
	-- Grass to Dirt
	if Actual_Material == 2 then Actual_Material = 3 end
	-- Cobblestone
	if Actual_Material == 4 then Locked, Dig_Time = 1, 0.5 end
	-- Wood
	if Actual_Material == 5 then Locked, Dig_Time = 1, 0.5 end
	-- Water
	if Actual_Material == 8 then Number = 0 end
	-- Lava
	if Actual_Material == 10 then Number = 0 end
	-- Goldore
	if Actual_Material == 14 then Locked, Dig_Time = 1, 4 end
	-- Ironore
	if Actual_Material == 15 then Locked, Dig_Time = 1, 3 end
	-- Coal
	if Actual_Material == 16 then Locked, Dig_Time = 1, 2 end
	-- Trunk to Wood
	if Actual_Material == 17 then Dig_Time, Actual_Material, Number = 1, 5, 5 end
	-- Leaves to Plant
	if Actual_Material == 18 then Actual_Material = 6 end
	-- Glass
	if Actual_Material == 20 then Locked, Dig_Time = 1, 0.5 end
	-- Cloth: Red (Doorswitch)
	if Actual_Material == 21 then Locked, Number = 1, 0 end
	-- Cloth:
	if Actual_Material == 22 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 23 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 24 then Locked = 1 end
	-- Cloth: Green (Doorswitch)
	if Actual_Material == 25 then Locked, Number = 1, 0 end
	-- Cloth:
	if Actual_Material == 26 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 27 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 28 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 29 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 30 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 31 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 32 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 33 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 34 then Locked = 1 end
	-- Cloth:
	if Actual_Material == 35 then Locked = 1 end
	-- Cloth: White
	if Actual_Material == 36 then Locked = 1 end
	-- Gold
	if Actual_Material == 41 then Locked, Dig_Time = 1, 0.5 end
	-- Ironblock
	if Actual_Material == 42 then Locked, Dig_Time = 1, 0.5 end
	-- Doublestair to Stair
	if Actual_Material == 43 then Locked, Dig_Time, Actual_Material = 1, 0.5, 44 end
	-- Stair
	if Actual_Material == 44 then Locked, Dig_Time = 1, 0.5 end
	-- Brick
	if Actual_Material == 45 then Locked, Dig_Time = 1, 0.5 end
	-- Bookcase
	if Actual_Material == 47 then Locked, Dig_Time = 1, 0.5 end
	-- Mossy Cobblestone
	if Actual_Material == 48 then Locked, Dig_Time = 1, 0.5 end
	-- Diamondore
	if Actual_Material == 56 then Locked, Dig_Time = 1, 5 end
	-- Diamond
	if Actual_Material == 57 then Locked, Dig_Time = 1, 0.5 end
	-- Workbench
	if Actual_Material == 58 then Locked, Dig_Time = 1, 0.5 end
	-- Furnace
	if Actual_Material == 59 then Locked, Dig_Time = 1, 0.5 end
	
	if Player_Attribute_Long_Get(Player_Number, "Dig_Time") - os.clock()*100 > 10 then
		Player_Attribute_Long_Set(Player_Number, "Dig_Time", 0)
	end
	
	if Player_Attribute_Long_Get(Player_Number, "Dig_Time") < os.clock()*100 then
		Player_Attribute_Long_Set(Player_Number, "Dig_Time", (os.clock()+Dig_Time)*100)
	elseif Mode == 0 then
		System_Message_Network_Send(Client_ID, "&cYou can't dig too fast!")
		return 0
	end
	
	if Locked == 1 then
		Block_Player_Number = Map_Block_Get_Player_Last(Map_ID, X, Y, Z)
		if Player_Number ~= Block_Player_Number and Block_Player_Number ~= -1 then
			System_Message_Network_Send(Client_ID, "&cIt's not your Block!")
			return 0
		end
	end
	
	if Number > 0 then
		Gamemode_RP_Player_Inventory_Add(Client_ID, Actual_Material, Number)
	end
	
	return 1
end

function Gamemode_RP_Anti_Noclip(Map_ID, Client_ID)
	Player_Number = Client_Get_Player_Number(Client_ID)
	if Player_Attribute_Long_Get(Player_Number, "rpoff") == 0 then
		X, Y, Z = math.floor(Client_Get_X(Client_ID)), math.floor(Client_Get_Y(Client_ID)), math.floor(Client_Get_Z(Client_ID))
		
		Type_0 = Map_Block_Get_Type(Map_ID, X, Y, Z)
		Type_1 = Map_Block_Get_Type(Map_ID, X, Y, Z+1)
		
		Kill = 0
		
		if Type_0 ~= 0 and Type_0 ~= 6 and Type_0 ~= 8 and Type_0 ~= 9 and Type_0 ~= 37 and Type_0 ~= 38 and Type_0 ~= 39 and Type_0 ~= 40 then
			if Type_1 ~= 0 and Type_1 ~= 6 and Type_1 ~= 8 and Type_0 ~= 9 and Type_1 ~= 37 and Type_1 ~= 38 and Type_1 ~= 39 and Type_1 ~= 40 then
				Kill = 1
			end
		end
		
		if Kill == 1 then
			New_X, New_Y, New_Z, New_Rot, New_Look = Map_Get_Spawn(Map_ID)
			Client_Position_Set(Client_ID, Map_ID, New_X, New_Y, New_Z, New_Rot, New_Look, 1, -1)
			System_Message_Network_Send(Client_ID, "&cDont noclip!")
		end
	end
end

function Gamemode_RP_Mob_AI()
	Gamemode_RP_Mob_AI_IDs = {}
	
	Counter = 0
	Client_Examine()
	while Client_Next() ~= 0 do
		local Client_ID = Client_Get_ID()
		if Client_ID < 0 and Client_Get_Name(Client_ID) == "ATM" then
		--if Client_ID < 0 then
			Gamemode_RP_Mob_AI_IDs[Counter] = Client_ID
			Counter = Counter + 1
		end
	end
	
	if Counter > 0 then
		for i = 0, Counter-1 do
			local Mob_Client_ID = Gamemode_RP_Mob_AI_IDs[i]
			local Map_ID = Client_Get_Map_ID(Mob_Client_ID)
			local Player_Number = Client_Get_Player_Number(Mob_Client_ID)
			
			Client_Physic_Set(Mob_Client_ID, 1, -9.81)
			
			Direction = math.rad(180-Client_Get_Rotation(Mob_Client_ID) + (math.random(360)-180) / 4)
			
			X = Client_Get_X(Mob_Client_ID)
			Y = Client_Get_Y(Mob_Client_ID)
			Z = Client_Get_Z(Mob_Client_ID)
			
			Dest_X = X + math.sin(Direction)*5
			Dest_Y = Y + math.cos(Direction)*5
			Dest_Z = Z
			
			Walk_Material = Map_Block_Get_Type(Map_ID, math.floor(Dest_X), math.floor(Dest_Y), math.floor(Dest_Z)-1)
			Walk_Material_Down_1 = Map_Block_Get_Type(Map_ID, math.floor(Dest_X), math.floor(Dest_Y), math.floor(Dest_Z)-2)
			Walk_Material_Down_2 = Map_Block_Get_Type(Map_ID, math.floor(Dest_X), math.floor(Dest_Y), math.floor(Dest_Z)-3)
			if Walk_Material == 8 or Walk_Material == -1 then
				Dest_X = X - math.sin(Direction)*0.25
				Dest_Y = Y - math.cos(Direction)*0.25
				Dest_Z = Z
			elseif Walk_Material == 0 and Walk_Material_Down_1 == 0 and Walk_Material_Down_2 == 0 then
				Dest_X = X - math.sin(Direction)*0.25
				Dest_Y = Y - math.cos(Direction)*0.25
				Dest_Z = Z
			end
			Client_Move_Interpolated(Mob_Client_ID, Dest_X, Dest_Y, Dest_Z, 2)
		end
	end
end

function Gamemode_RP_Mob_Add(Amount)
	Client_Examine()
	while Client_Next() ~= 0 do
		Client_ID = Client_Get_ID()
		if Client_ID < 0 and Client_Get_Name(Client_ID) == "ATM" then
			Client_Kick(Client_ID, "hm, sorry. You shouldn't get kicked :/", 1)
		end
	end
	
	if Amount > 0 then
		for i = 1, Amount do
			New_Client = Client_Fake_Add("ATM", 30)
			Client_Physic_Set(New_Client, 1, -9.81)
			Client_Position_Set(New_Client, 282, 50, 50, 120, 0, 0, 1, 10)
		end
	end
end

function Gamemode_RP_Ressource_Add()
	local Map_ID = 282
	local Map_X, Map_Y, Map_Z = Map_Get_Dimensions(Map_ID)
	
	for i = 1, 50000 do
		local X = math.random(Map_X)-1
		local Y = math.random(Map_Y)-1
		local Z = math.random(Map_Z)-1
		local Radius = math.random()*4
		
		local Material = 14 + math.random(4)-1
		if Material == 14 then Radius = Radius / 3 end
		if Material == 17 then Material, Radius = 56, Radius / 3 end
		
		for New_X = -Radius, Radius do
			for New_Y = -Radius, Radius do
				for New_Z = -Radius, Radius do
					local Entf = New_X*New_X + New_Y*New_Y + New_Z*New_Z
					if Entf < Radius*Radius then
						local Type_0 = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z)
						local Type_1 = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z + 1)
						local Type_2 = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z + 2)
						if Type_0 == 1 then
							if Type_1 ~= 0 and Type_2 ~= 0 then
								Map_Block_Change_Fast(-1, Map_ID, X + New_X, Y + New_Y, Z + New_Z, Material, 5, 0, 0, 0)
							end
						end
					end
				end
			end
		end
	end
	
	Map_Resend(Map_ID)
	System_Message_Network_Send_2_All(Map_ID, "&c Ressources created!")
end

function Gamemode_RP_Caves_Add()
	local Map_ID = 282
	local Map_X, Map_Y, Map_Z = Map_Get_Dimensions(Map_ID)
	
	for i = 1, 4000 do
		local X = math.random(Map_X)-1
		local Y = math.random(Map_Y)-1
		local Z = math.random(Map_Z)-1
		local Radius = math.random()*10
		
		for New_X = -Radius, Radius do
			for New_Y = -Radius, Radius do
				for New_Z = -Radius, Radius do
					local Entf = New_X*New_X + New_Y*New_Y + New_Z*New_Z*4
					if Entf < Radius*Radius then
						local Type_0 = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z)
						local Type_1 = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z + 1)
						local Type_2 = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z + 2)
						if Type_0 == 1 or Type_0 == 3 then
							if Type_1 == 1 or Type_1 == 3 then
								if Type_2 == 1 or Type_2 == 3 then
									Map_Block_Change_Fast(-1, Map_ID, X + New_X, Y + New_Y, Z + New_Z, 0, 5, 0, 0, 0)
								end
							end
						end
					end
				end
			end
		end
	end
	
	Map_Resend(Map_ID)
	System_Message_Network_Send_2_All(Map_ID, "&c Caves created!")
end

function Gamemode_RP_Trees_Add(Amount)
	local Map_ID = 282
	local Map_X, Map_Y, Map_Z = Map_Get_Dimensions(Map_ID)
	
	local i
	for i = 1, Amount do
		local X = math.random(Map_X)-1
		local Y = math.random(Map_Y)-1
		
		local j
		for j = Map_Z, 0, -1 do
			if Map_Block_Get_Type(Map_ID, X, Y, j) == 2 then
				Place_Tree(Map_ID, X, Y, j, 3+math.random(3))
			end
		end
	end
	
	Map_Resend(Map_ID)
	System_Message_Network_Send_2_All(Map_ID, "&c Trees created!")
end

function Gamemode_RP_Flowers_Add(Amount)
	local Map_ID = 282
	local Map_X, Map_Y, Map_Z = Map_Get_Dimensions(Map_ID)
	
	local i
	for i = 1, Amount do
		local X = math.random(Map_X)-1
		local Y = math.random(Map_Y)-1
		
		local j
		for j = Map_Z, 0, -1 do
			if Map_Block_Get_Type(Map_ID, X, Y, j) == 2 then
				Material = 36 + math.random(4)
				Map_Block_Change_Fast(-1, Map_ID, X, Y, j+1, Material, 5, 0, 0, 1)
			end
		end
	end
	
	System_Message_Network_Send_2_All(Map_ID, "&c Flowers created!")
end

function Gamemode_RP_Fill(Trees)
	Gamemode_RP_Trees_Add(Trees)
	Gamemode_RP_Caves_Add()
	Gamemode_RP_Ressource_Add()
end

function Gamemode_RP_Inventorys_Reset()
	Player_Examine()
	while Player_Next() ~= 0 do
		local Player_Number = Player_Get_Number()
		for i = 0,255 do
			Player_Inventory_Set(Player_Number, i, 0)
		end
	end
	System_Message_Network_Send_2_All(Map_ID, "&c Inventorys resetted!")
end

function Gamemode_RP_Command_Inventory_Show(Client_ID, Command, Text_0, Text_1, Arg_0, Arg_1, Arg_2, Arg_3, Arg_4)
	local Player_Number = Client_Get_Player_Number(Client_ID)
	
	System_Message_Network_Send(Client_ID, "&eYour Inventory:")
	Text = ""
	for i = 0, 255 do
		Counter = Player_Inventory_Get(Player_Number, i)
		if Counter > 0 then
			Text_Add = "&f"..tostring(Counter).."x&e"..Block_Get_Name(i).." "
			if 64-string.len(Text) >= string.len(Text_Add) then
				Text = Text .. Text_Add
			else
				System_Message_Network_Send(Client_ID, Text)
				Text = Text_Add
			end
		end
		
	end
	if string.len(Text) > 0 then
		System_Message_Network_Send(Client_ID, Text)
	end
	
end

function Gamemode_RP_Command_Give(Client_ID, Command, Text_0, Text_1, Arg_0, Arg_1, Arg_2, Arg_3, Arg_4)
	local Player_Number = Client_Get_Player_Number(Client_ID)
	
	To_Player = Arg_0
	To_Player_Number = Player_Name_2_Number(To_Player)
	Amount = tonumber(Arg_1)
	Material = Arg_2
	Material_Found = 0
	for i = 0, 255 do
		if string.lower(Block_Get_Name(i)) == string.lower(Material) then
			Material_ID = i
			Material_Found = 1
			break
		end
	end
	
	if To_Player_Number ~= -1 then
		if Material_Found == 1 then
			if Player_Inventory_Get(Player_Number, Material_ID) >= Amount then
				Player_Inventory_Set(Player_Number, Material_ID, Player_Inventory_Get(Player_Number, Material_ID)-Amount)
				Player_Inventory_Set(To_Player_Number, Material_ID, Player_Inventory_Get(To_Player_Number, Material_ID)+Amount)
				Client_Examine()
				while Client_Next() ~= 0 do
					local To_Client_ID = Client_Get_ID()
					if Client_Get_Name(To_Client_ID) == To_Player then
						System_Message_Network_Send(To_Client_ID, "&eYou got "..tostring(Amount).."x"..Material.." from "..Client_Get_Name(Client_ID))
					end
				end
				System_Message_Network_Send(Client_ID, "&eYou gave "..tostring(Amount).."x"..Material.." to "..To_Player)
			else
				System_Message_Network_Send(Client_ID, "&c Not enough Material!")
			end
		else
			System_Message_Network_Send(Client_ID, "&c Material not found!")
		end
	else
		System_Message_Network_Send(Client_ID, "&c Player not found!")
	end
	
end

System_Message_Network_Send_2_All(282, "&b RP-Script reloaded!")