Block_Type = Map_Block_Get_Type(Physic_Map_ID, Physic_X, Physic_Y, Physic_Z)

Map_Block_Change(0, Physic_Map_ID, Physic_X, Physic_Y, Physic_Z, 0, 0, 5)

Iterations = 2--4

local Counter = {}
for i = 0, 500 do
	Counter[i] = {}
end

Size = 1

for i = 1, 19 do
	Type = Map_Block_Get_Type(Physic_Map_ID, Physic_X + i + 1, Physic_Y + i + 1, Physic_Z)
	if Type == 43 or Type == 44 then
		Size = i
	end
end

for ix = 0, Size do
	for iy = 0, Size do
		Counter[ix][iy] = 0
	end
end

for ix = 0, Size do
	for iy = 0, Size do
		for iz = 0, 5 do
			if Map_Block_Get_Type(Physic_Map_ID, Physic_X + ix + 1, Physic_Y + iy + 1, Physic_Z + iz) == 43 then
				Counter[ix][iy] = Counter[ix][iy] + 16
			elseif Map_Block_Get_Type(Physic_Map_ID, Physic_X + ix + 1, Physic_Y + iy + 1, Physic_Z + iz) == 44 then
				Counter[ix][iy] = Counter[ix][iy] + 8
			end
		end
	end
end

--Counter[0][0] = 10
--Counter[0][1] = 10
--Counter[0][2] = 10
--Counter[1][0] = 10
--Counter[1][1] = 20
--Counter[1][2] = 10
--Counter[2][0] = 20
--Counter[2][1] = 50
--Counter[2][2] = 60

Height_Dirt = 0
Height_Stone = 18
Height_White = 25

for i = 1, Iterations do
	if i >= Iterations-1 then
		RND_Factor = 0
	else
		RND_Factor = 0.006*(Iterations-i)
	end
	
	for ix = Size, 0, -1 do
		for iy = Size, 0, -1 do
			Counter[ix*2][iy*2] = Counter[ix][iy]
		end
	end
	for ix = 0, Size-1 do
		for iy = 0, Size-1 do
			Counter[ix*2][iy*2+1] = (Counter[ix*2][iy*2] + Counter[ix*2][iy*2+2]) / 2 + ((math.random(255)-128)*RND_Factor)
			Counter[ix*2+2][iy*2+1] = (Counter[ix*2+2][iy*2] + Counter[ix*2+2][iy*2+2]) / 2 + ((math.random(255)-128)*RND_Factor)
			
			Counter[ix*2+1][iy*2] = (Counter[ix*2][iy*2] + Counter[ix*2+2][iy*2]) / 2 + ((math.random(255)-128)*RND_Factor)
			Counter[ix*2+1][iy*2+2] = (Counter[ix*2][iy*2+2] + Counter[ix*2+2][iy*2+2]) / 2 + ((math.random(255)-128)*RND_Factor)
			
			Counter[ix*2+1][iy*2+1] = (Counter[ix*2][iy*2] + Counter[ix*2+2][iy*2] + Counter[ix*2][iy*2+2] + Counter[ix*2+2][iy*2+2]) / 4 + ((math.random(255)-128)*RND_Factor)
		end
	end
	Size = Size * 2
end

for ix = 0, Size do
	for iy = 0, Size do
		Height = math.ceil(Counter[ix][iy])
		X = Physic_X + ix
		Y = Physic_Y + iy
		for iz = 0, Height+10 do
			Z = iz
			if iz <= Height then
				if iz > Height_White then
					Map_Block_Change(0, Physic_Map_ID, X, Y, Z, 1, 36, 5)
				elseif iz > Height_Stone then
					Map_Block_Change(0, Physic_Map_ID, X, Y, Z, 1, 1, 5)
				elseif iz > Height_Dirt then
					if iz == Height then
						Map_Block_Change(0, Physic_Map_ID, X, Y, Z, 1, 2, 6)
					else
						Map_Block_Change(0, Physic_Map_ID, X, Y, Z, 1, 3, 4)
					end
				end
			else
				Map_Block_Change(0, Physic_Map_ID, X, Y, Z, 0, 0, 5)
			end
		end
	end
end

System_Message_Network_Send_2_All(Physic_Map_ID, "&cTerrain generated")