function Physic_Special_Ventilator(Map_ID, X, Y, Z)
	
	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)
	
	Radius = 3
	Material = 5
	Rotation = os.clock() * math.pi / 2
	
	for ix = -Radius, Radius do
		for iy = -Radius, Radius do
			if ix ~= 0 or iy ~= 0 then
				if Map_Block_Get_Type(Map_ID, X + ix, Y + iy, Z) == Material then
					Map_Block_Change(0, Map_ID, X + ix, Y + iy, Z, 0, 0, 5)
				end
				for ir = -Radius, Radius do
					if  ir ~= 0 then
						Rot_X = math.cos(Rotation) * ir
						Rot_Y = math.sin(Rotation) * ir
						Map_Block_Change(0, Map_ID, X + Rot_X, Y + Rot_Y, Z, 1, Material, 5)
					end
				end
			end
		end
	end
	
end
