function Physic_Special_Drocket(Map_ID, X, Y, Z)

	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)

	Material_1 = 244 -- Dynamite (Rocket head)
	Material_2 = 223 -- Spark (vector)
	Material_3 = 41 -- Gold (vector)
	Material_4 = 225 -- Red Spark

	Vector_X = 0
	Vector_Y = 0
	Vector_Z = 0
	Found = 0

	for ix = -1, 1 do
		for iy = -1, 1 do
			for iz = -1, 1 do
				if Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z+iz) == Material_2 then
					Vector_X = ix
					Vector_Y = iy
					Vector_Z = iz
					Found = 1
				end
				if Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z+iz) == Material_3 then
					Vector_X = ix
					Vector_Y = iy
					Vector_Z = iz
					Found = 1
				end
				if Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z+iz) == 41 then
					if Map_Block_Get_Type(Map_ID, X-ix, Y-iy, Z-iz) == 0 then
					else
						Map_Block_Change_Fast(Player_Number, Map_ID, X, Y, Z, 0, 5, 0, 0, 1)
						for New_X = -Radius, Radius do
							for New_Y = -Radius, Radius do
								for New_Z = -Radius, Radius do
									Entf = New_X*New_X + New_Y*New_Y + New_Z*New_Z
									if Entf < Radius*Radius then
										New_Type = Map_Block_Get_Type(Map_ID, X + New_X, Y + New_Y, Z + New_Z)
										if New_Type ~= Block_Type then
											Map_Block_Change_Fast(Player_Number, Map_ID, X + New_X, Y + New_Y, Z + New_Z, Material, 5, 1, 0, 1)
										end
									end
								end
							end
						end
						for i = 0, 40, 1 do
							New_X = X + math.random(Radius) - Radius
							New_Y = Y + math.random(Radius) - Radius
							New_Z = Z + math.random(Radius) - Radius
							if Map_Block_Get_Type(Map_ID, New_X, New_Y, New_Z) == 0 then
								Map_Block_Change_Fast(Player_Number, Map_ID, New_X, New_Y, New_Z, 230, 6, 1, 1, 1)
							end
						end
					end
				end
			end
		end
	end
	if Found == 1 then
			Map_Block_Move(Map_ID, X, Y, Z, X-Vector_X, Y-Vector_Y, Z-Vector_Z, 2, 1, 1)
			Map_Block_Move(Map_ID, X+Vector_X, Y+Vector_Y, Z+Vector_Z, X, Y, Z, 2, 1, 1)
			Map_Block_Change_Fast(-1, Map_ID, X+Vector_X, Y+Vector_Y, Z+Vector_Z, Material_4, 5, 0, 0, 1)
	end
end