function tonum(x)
	if x == nil or x == false then
		return 0
	end
	return x
end

function getPos(Client_ID)
	return Client_Get_X(Client_ID),Client_Get_Y(Client_ID),Client_Get_Z(Client_ID)
end

function getClients()
	local Clients = {}
	Client_Examine()
	while Client_Next() ~= 0 do
		local Client_ID = Client_Get_ID()
		Clients[Client_ID] = Client_Get_Player_Number(Client_ID)
	end
end

function getPlayerByName(searchName)
	local searchName = string.lower(searchName)
	Player_Examine()
	while Player_Next() ~= 0 do
		local playerID = Player_Get_Number()
		local playerName = Player_Get_Name(playerID)
		if string.lower(playerName) == searchName then
			return playerID
		end
	end
	return -1
end

function sendClientMessage(Client_ID, ...)
	for i,v in ipairs({...}) do
		System_Message_Network_Send(Client_ID, v)
	end
end