Block_Type = Map_Block_Get_Type(Physic_Map_ID, Physic_X, Physic_Y, Physic_Z)

Type_Dead = 21
Type_Living = 25--12
Type_Block = 49

Size_X = 100
Size_Y = 100

local Counter = {}
number = 0

for i = 1, (Size_X+Size_Y*Size_X) do
	Counter[i] = 0
end

for ix = 1, Size_X do
	for iy = 1, Size_Y do
		for ixx = -1, 1 do
			for iyy = -1, 1 do
				if ixx ~= 0 or iyy ~= 0 then
					if Map_Block_Get_Type(Physic_Map_ID, Physic_X + ix + ixx, Physic_Y + iy + iyy, Physic_Z) == Type_Living then
						Counter[(ix+iy*Size_X)] = Counter[(ix+iy*Size_X)] + 1
					end
				end
			end
		end
	end
end

for ix = 1, Size_X do
	for iy = 1, Size_Y do
		number = (ix+iy*Size_X)
		temp = Counter[number]
		if Map_Block_Get_Type(Physic_Map_ID, Physic_X + ix, Physic_Y + iy, Physic_Z) ~= Type_Block then
			if temp == 3 then
				Map_Block_Change_Fast(-1, Physic_Map_ID, Physic_X + ix, Physic_Y + iy, Physic_Z, Type_Living, 4, 0, 0, 1)
			elseif temp ~= 2 then
				Map_Block_Change_Fast(-1, Physic_Map_ID, Physic_X + ix, Physic_Y + iy, Physic_Z, Type_Dead, 4, 0, 0, 1)
			end
		end
	end
end
