function Physic_Special_Vent0(Map_ID, X, Y, Z)

	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)

	Radius = 3
	Material_1 = 5 -- fan material
	Material_2 = 49 -- directional material
	Rotation = os.clock() * math.pi / 2

	for ix = -1, 1 do
		for iy = -1, 1 do
			for iz = -1, 1 do
				if Map_Block_Get_Type(Map_ID, X+ix, Y, Z) == Material_2 then
					Found = 1
					-- System_Message_Network_Send_2_All(Map_ID, "Fan 2 enabled")
				else
					if Map_Block_Get_Type(Map_ID, X, Y+iy, Z) == Material_2 then
						Found = 2
						-- System_Message_Network_Send_2_All(Map_ID, "Fan 1 enabled")
					else
						if Map_Block_Get_Type(Map_ID, X, Y, Z+iz) == Material_2 then
							Found = 3
							-- System_Message_Network_Send_2_All(Map_ID, "Fan enabled")
						else
							Found = 0
						end
					end
				end
			end
		end
	end


	if Found == 3 then

	for ix = -Radius, Radius do
		for iy = -Radius, Radius do
			if ix ~= 0 or iy ~= 0 then
				if Map_Block_Get_Type(Map_ID, X + ix, Y + iy, Z) == Material_1 then
					Map_Block_Change(0, Map_ID, X + ix, Y + iy, Z, 0, 0, 5)
				end
				for ir = -Radius, Radius do
					if  ir ~= 0 then
						Rot_X = math.cos(Rotation) * ir
						Rot_Y = math.sin(Rotation) * ir
						Map_Block_Change(0, Map_ID, X + Rot_X, Y + Rot_Y, Z, 1, Material_1, 5)
					end
				end
			end
		end

	if Found = 2 then

	System_Message_Network_Send_2_All(Map_ID, "Fan working")

	for ix = -Radius, Radius do
		for iz = -Radius, Radius do
			if ix ~= 0 or iz ~= 0 then
				if Map_Block_Get_Type(Map_ID, X + ix, Y, Z+ iz) == Material_1 then
					Map_Block_Change(0, Map_ID, X + ix, Y, Z+ iz, 0, 0, 5)
				end
				for ir = -Radius, Radius do
					if  ir ~= 0 then
						Rot_X = math.cos(Rotation) * ir
						Rot_Z = math.sin(Rotation) * ir
						Map_Block_Change(0, Map_ID, X + Rot_X, Y, Z + Rot_Z, 1, Material_1, 5)
					end
				end
			end
		end


	if Found = 1 then

		for iy = -Radius, Radius do
			for iz = -Radius, Radius do
				if iz ~= 0 or iy ~= 0 then
					if Map_Block_Get_Type(Map_ID, X, Y + iy, Z + iz) == Material_1 then
					Map_Block_Change(0, Map_ID, X, Y + iy, Z + iz, 0, 0, 5)
					end
					for ir = -Radius, Radius do
						if  ir ~= 0 then
							Rot_Y = math.cos(Rotation) * ir
							Rot_Z = math.sin(Rotation) * ir
							Map_Block_Change(0, Map_ID, X , Y + Rot_Y, Z + Rot_Z, 1, Material_1, 5)
						end
					end
				end
			end
		end
	end
end
