function Physic_Special_Vent3(Map_ID, X, Y, Z)

	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)

	Radius = 3
	Material = 5
	Rotation = os.clock() * math.pi / 2

	for iy = -Radius, Radius do
		for iz = -Radius, Radius do
			if iz ~= 0 or iy ~= 0 then
				if Map_Block_Get_Type(Map_ID, X, Y + iy, Z + iz) == Material then
					Map_Block_Change(0, Map_ID, X, Y + iy, Z + iz, 0, 0, 5)
				end
				for ir = -Radius, Radius do
					if  ir ~= 0 then
						Rot_Y = math.cos(Rotation) * ir
						Rot_Z = math.sin(Rotation) * ir
						Map_Block_Change(0, Map_ID, X , Y + Rot_Y, Z + Rot_Z, 1, Material, 5)
					end
				end
			end
		end
	end

end
