function  Physic_Special_Dehod(Map_ID, X, Y, Z)
	Player_Number = Map_Block_Get_Player_Last(Map_ID, X, Y, Z)
	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)

 local Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)
 local body = Map_Block_Get_Type(Map_ID, X, Y, Z-1)
 
 for a = 0, 3 do
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y+1, Z, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y, Z, 44, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y+1, Z+1, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X, Y+1, Z+1, 44, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y-1, Z+2, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y, Z+2, 44, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y-1, Z+3, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X, Y-1, Z+3, 44, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X, Y, Z+a, body, 5, 0, 0, 1)
     end
 end
 
 
function  Physic_Special_Dehod2(Map_ID, X, Y, Z)
	Player_Number = Map_Block_Get_Player_Last(Map_ID, X, Y, Z)
	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)

 local Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)
 local body = Map_Block_Get_Type(Map_ID, X, Y, Z-1)
 local body2 = 44
 
 if body == 0 then
     body2 = 0
 end
 
 for a = 1, 3 do
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y, Z, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y+1, Z, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y+1, Z+1, body2, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X, Y+1, Z+1, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y+1, Z+1, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y+1, Z+2, body2, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y, Z+2, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y-1, Z+2, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X-1, Y-1, Z+3, body2, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X, Y-1, Z+3, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y-1, Z+3, body, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X+1, Y-1, Z, body2, 5, 0, 0, 1)
     Map_Block_Change_Fast(-1, Map_ID, X, Y, Z+a, body, 5, 0, 0, 1)
     end
 end
 
function  Physic_Special_Dehod3(Map_ID, X, Y, Z)
	Player_Number = Map_Block_Get_Player_Last(Map_ID, X, Y, Z)
	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)

 local Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)
 local vx = 0
 local vy = 0
 local vz = 0
 local material = 243
 
 for ix = -1, 1 do
     if Map_Block_Get_Type(Map_ID, X-ix, Y, Z) == 21 then
         vx = ix
     end
 end
 
 for iy = -1, 1 do
     if Map_Block_Get_Type(Map_ID, X, Y-iy, Z) == 21 then
          vy = iy
      end
 end
 
 for iz = -1, 1 do
      if Map_Block_Get_Type(Map_ID, X, Y, Z-iz) == 21 then
          vz = iz
      end
 end
 
 if ix == 0 and iy == 0 and iz == 0 then return end
     
 Map_Block_Change_Fast(-1, Map_ID, X-vx, Y, Z, material, 5, 0, 1, 1)
 Map_Block_Change_Fast(-1, Map_ID, X, Y-vy, Z, material, 5, 0, 1, 1)
 Map_Block_Change_Fast(-1, Map_ID, X, Y, Z-vz, material, 5, 0, 1, 1)
 end


function  Physic_Special_Dehod4(Map_ID, X, Y, Z)
	Player_Number = Map_Block_Get_Player_Last(Map_ID, X, Y, Z)

 local Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)
 local material1 = 17
 local material2 = 18
 
 for b = -2, 2 do
     for c = 2, 3 do
         for f = -2, 2 do
             Map_Block_Change_Fast(-1, Map_ID, X-b, Y-f, Z+c, material2, 5, 0, 0, 1)
         end
     end
 end
 for d = -1, 1 do
     for e = 4, 5 do
         for g = -1, 1 do
             Map_Block_Change_Fast(-1, Map_ID, X-d, Y-g, Z+e, material2, 5, 0, 0, 1)
         end
     end
 end
 for a = 0, 4 do
     Map_Block_Change_Fast(-1, Map_ID, X, Y, Z+a, material1, 5, 0, 0, 1)
 end
 end