function Physic_Special_Door(Map_ID, X, Y, Z)
	
	Block_Type = Map_Block_Get_Type(Map_ID, X, Y, Z)
	
	Material_1 = 43 -- Material der Tr (Rand)
	Material_2 = 20 -- Material der Tr
	Material_3 = 49 -- Material gibt richtung an
	Material_4 = 21 -- Material: Tr zu
	Material_5 = 25 -- Material: Tr auf
	
	Vector_X = 0
	Vector_Y = 0
	Found = 0
	
	for ix = -1, 1 do
		for iy = -1, 1 do
			if Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z) == Material_3 then
				Vector_X = ix
				Vector_Y = iy
				Found = 1
			end
		end
	end
	
	if Found == 1 then

		for i = 1, 10 do
			ix = i * Vector_X
			iy = i * Vector_Y
			if Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z) == Material_3 then
				Size_X = i
			else
				break
			end
		end
		Size_Z = Size_X
		for i = 1, 10 do
			ix = i * Vector_X
			iy = i * Vector_Y
			if Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z-1) == Material_3 then
				Size_Z = i
			else
				break
			end
		end

		i = Size_X+1
		ix = i * Vector_X
		iy = i * Vector_Y
		Material_1 = Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z)
		i = Size_X+2
		ix = i * Vector_X
		iy = i * Vector_Y
		Material_2 = Map_Block_Get_Type(Map_ID, X+ix, Y+iy, Z)
		
		if Material_1 ~= -1 and Material_2 ~= -1 then
			
			i = 1
			ix = i * Vector_X
			iy = i * Vector_Y
			
			Offset_Z = 0
			
			if Map_Block_Get_Type(Map_ID, X, Y, Z + 2 + Offset_Z) == Material_5 then
				Open = 1
			elseif Map_Block_Get_Type(Map_ID, X, Y, Z + 2 + Offset_Z) == Material_4 then
				Open = 0
			elseif Map_Block_Get_Type(Map_ID, X + ix, Y + iy, Z + 1 + Offset_Z) == Material_1 then
				Map_Block_Change(0, Map_ID, X, Y, Z + 2 + Offset_Z, 1, Material_5, 5)
				Open = 1
			else
				Map_Block_Change(0, Map_ID, X, Y, Z + 2 + Offset_Z, 1, Material_4, 5)
				Open = 0
			end
			
			for i = 1, Size_X do
				ix = i * Vector_X
				iy = i * Vector_Y
				if Open == 1 then
					for iz = 1, Size_Z do
						Map_Block_Change(0, Map_ID, X + ix, Y + iy, Z + iz + Offset_Z, 1, 0, 5)
					end
				else
					for iz = 1, Size_Z do
						if i == 1 or i == Size_X or iz == 1 or iz == Size_Z then
							Map_Block_Change(0, Map_ID, X + ix, Y + iy, Z + iz + Offset_Z, 1, Material_1, 5)
						else
							Map_Block_Change(0, Map_ID, X + ix, Y + iy, Z + iz + Offset_Z, 1, Material_2, 5)
						end
					end
				end
			end
			
		end
	end
	
end
